/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFF̑}

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void appendWatermark(PtlPDFDocument& doc);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: AppendColorWatermark.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// ̐ݒ
		appendWatermark(doc);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void appendWatermark(PtlPDFDocument& doc)
{
	PtlParamWaterMarkColor watermarkcolor;

	//̖O̐ݒ
	watermarkcolor.setName("̖O");

	//zu}[W̐ݒ
	watermarkcolor.setMargin(10.0f, 10.0f, 10.0f, 10.0f);

	//ZI[_[̐ݒ ZORDER_BACK /* w */
	watermarkcolor.setZorder(PtlParamWaterMark::ZORDER_BACK);

	//y[W͈̔͂̐ݒ PAGE_RANGE_ALL = 0 /* Sy[W */
	watermarkcolor.setPageRange(PtlParamWaterMark::PAGE_RANGE_ALL);

	//̕sx̐ݒ
	watermarkcolor.setOpacity(0.4f);

	//̐F̐ݒ
	watermarkcolor.setColor(PtlColorDeviceRGB(1.0f, 0.0f, 0.0f));

	//̐ݒ
	doc.appendWaterMark(watermarkcolor);

}
