/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFt@C̓Yt

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: AppendEmbeddedFile.exe in-pdf-file out-pdf-file embedded-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlParamString embeddedfilename(argv[3]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// Ytt@CRei̎擾
		PtlEmbeddedFiles& embeddedfiles = doc.getEmbeddedFiles();

		// Ytt@C̎擾
		printf("ǉO̓Ytt@C : %d\n", embeddedfiles.getCount());

		// PDF̓Ytt@C
		PtlEmbeddedFile embeddedfile;

		// Ytt@C̐ݒ
		embeddedfile.setFileName(embeddedfilename);

		// Ytt@C̓ǂݍ
		PtlParamInput inputEmbed(embeddedfilename);
		embeddedfile.readFile(inputEmbed);

		// Ytt@C̒ǉ
		embeddedfiles.append(embeddedfile);

		// Ytt@C̎擾
		printf("ǉ̓Ytt@C : %d\n", embeddedfiles.getCount());

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

