/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF̒ǉ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void createOutline(PtlOutline& outlineRoot);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: AppendOutline.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		//[gAEgC̎擾
		PtlOutline outlineRoot = doc.getRootOutline();

		// ̒ǉ
		createOutline(outlineRoot);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void createOutline(PtlOutline& outlineRoot)
{
	PtlOutline outlineActionGoTo;
	{
		outlineActionGoTo.setTitle("ActionGoTo DestFit");
		// ANV
		PtlActionGoTo actiongoto; // PtlActionGoTo : GoToANV<݂̃hLg̈ֈړ>
			// PtlDestFit : Fit^
			PtlDestFit destfit;
			// y[W̐ݒ
			destfit.setPageNumber(1);
			// ̐ݒ
		actiongoto.setDest(destfit);
		// ANV̐ݒ
		outlineActionGoTo.setAction(actiongoto);
		// AEgC^Cg̐Fݒ
		outlineActionGoTo.setColor(PtlColorDeviceRGB(0.0f, 1.0f, 0.0f));
		// AEgCtOݒ
		outlineActionGoTo.setFlags(PtlOutline::FLAG_ITALIC);
		// PDF\̎qAEgCI[v邩ǂ̐ݒ
		outlineActionGoTo.setOpen(true);
		// qAEgC̒ǉ
		outlineRoot.appendLastChild(outlineActionGoTo);

		PtlOutline outlineActionGoToR;
		{
			outlineActionGoToR.setTitle("ActionGoToR DestFitH");
			// ANV
			PtlActionGoToR actiongotor; // PtlActionGoToR : GoToRANV<("Go-to remote")̃hLgւ̈>
				PtlDestFitH destfith; // PtlDestFitH : FitH^
				// y[W̐ݒ
				destfith.setPageNumber(3);
				// top̐ݒ
				destfith.setTopNull();
				// dest1.setTop(NULL_VALUE_CSTR);
			// ̐ݒ
			actiongotor.setDest(destfith);
			// t@CԈړpPDFt@C擾it@C͑΃pXwj
			actiongotor.setFileName("test.pdf");
			// 敶VEBhEŃI[v邩ǂ̃tOݒitrue: VEBhEŃI[vBfalse: Ȃj
			actiongotor.setNewWindowFlag(false);
			// ANV̐ݒ
			outlineActionGoToR.setAction(actiongotor);

			// AEgC^Cg̐Fݒ
			outlineActionGoToR.setColor(PtlColorDeviceRGB(0.0f, 0.0f, 1.0f));
			// AEgCtOݒ
			outlineActionGoToR.setFlags(PtlOutline::FLAG_NORMAL);
			// PDF\̎qAEgCI[v邩ǂ̐ݒ
			outlineActionGoToR.setOpen(false);
			// qAEgC̒ǉ
			outlineActionGoTo.appendLastChild(outlineActionGoToR);
		}
	}

	PtlOutline outlineActionLaunch;
	{
		outlineActionLaunch.setTitle("ActionLaunch");
		// ANV
		PtlActionLaunch actionlaunch; // PtlActionLaunch : LaunchANV<AvP[V̋NAʏAt@CJ
		// Nt@Cݒ
		actionlaunch.setFileName("test.jpg");
		// 敶VEBhEŃI[v邩ǂ̃tOݒitrue: VEBhEŃI[v false: Ȃj
		actionlaunch.setNewWindowFlag(true);
		// ANV̐ݒ
		outlineActionLaunch.setAction(actionlaunch);
		// AEgC^Cg̐Fݒ
		outlineActionLaunch.setColor(PtlColorDeviceRGB(0.0f, 1.0f, 1.0f));
		// AEgCtOݒ
		outlineActionLaunch.setFlags(PtlOutline::FLAG_BOLD);
		// PDF\̎qAEgCI[v邩ǂ̐ݒ
		outlineActionLaunch.setOpen(false);
		// qAEgC̒ǉ
		outlineRoot.appendLastChild(outlineActionLaunch);
	}

	PtlOutline outlineActionURI;
	{
		// AEgC^Cgݒ
		outlineActionURI.setTitle("ActionURI");
		// ANV
		PtlActionURI actionuri; // PtlActionURI : URIANV
		// URIݒ
		actionuri.setURI("http://www.antenna.co.jp/");
		// ANV̐ݒ
		outlineActionURI.setAction(actionuri);
		// AEgC^Cg̐Fݒ
		outlineActionURI.setColor(PtlColorDeviceRGB(.01f, 0.5f, 0.0f));
		// AEgCtOݒ
		outlineActionURI.setFlags(PtlOutline::FLAG_BOLD | PtlOutline::FLAG_ITALIC);
		// PDF\̎qAEgCI[v邩ǂ̐ݒ
		outlineActionURI.setOpen(true);
		// qAEgC̒ǉ
		outlineRoot.appendLastChild(outlineActionURI);
	}
}
