/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFPDF̑}

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void appendWatermark(PtlPDFDocument& doc, const char* pathPdf);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: AppendPdfWatermark.exe in-pdf-file out-pdf-file watermark-pdf\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// ̒ǉ
		appendWatermark(doc, argv[3]);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void appendWatermark(PtlPDFDocument& doc, const char* pathPdf)
{
	PtlPDFDocument doc_watermark;

	PtlParamInput watermark(pathPdf);

	// PDFt@C[h܂B
	doc_watermark.load(watermark);

	// y[WRei̎擾
	PtlPages& pages = doc_watermark.getPages();
	// y[WRei󂩂ǂ
	if (pages.isEmpty()) {
		printf("y[WRei\n");
		return;
	}

	// ̐ݒ
	PtlParamWaterMarkPDF watermarkpdf;

	// ̖O̐ݒ
	watermarkpdf.setName("̖O");

	// ̔zu̐ݒ ALIGN_CENTER = 5 /*  */
	watermarkpdf.setAlign(PtlParamWaterMark::ALIGN_CENTER);

	// ZI[_[̐ݒ ZORDER_FRONT = 1 /* O */
	watermarkpdf.setZorder(PtlParamWaterMark::ZORDER_FRONT);

	// y[W͈̔͂̐ݒ PAGE_RANGE_ALL = 0 /* Sy[W */
	watermarkpdf.setPageRange(PtlParamWaterMark::PAGE_RANGE_ALL);

	// 擪y[WɓzuȂݒ͈̔͂̐ݒ
	watermarkpdf.setNotInFirst(false);

	// ŏIy[WɓzuȂݒ̐ݒ
	watermarkpdf.setNotInLast(false);

	// PDF\ɓ\w̐ݒ
	watermarkpdf.setDisplayWaterMark(true);

	// PDFɓw̐ݒ
	watermarkpdf.setPrintWaterMark(true);

	// ̕sx̐ݒ
	watermarkpdf.setOpacity(0.5f);
		
	// ^COĔzu邩ǂ̐ݒ
	watermarkpdf.setTiling(false);

	// Ɏgpy[W̎擾
	PtlPage page = pages.get(0);

	// ɎgpPDFy[Wݒ
	watermarkpdf.setPage(page);

	// ̔{̐ݒ
	watermarkpdf.setScale(0.5f);

	// ̐ݒ
	doc.appendWaterMark(watermarkpdf);
}
