/*
	Antenna House PDF Tool API V6.0
	C++ Interface sample program

	TvFZLeB̐ݒ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void setEncrypt(PtlEncryptStandard& enc);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: Encrypt.exe in-pdf-file out-pdf-file Í [in-pdf-password]\n");
		printf("Í\n0 : 128 bit RC4  1 : 128 bit AES  2 : 256 bit AES \n");
		return 1;
	}
	try
	{
		switch (argv[3][0]) {
		case '0':
		case '1':
			break;
		default:
			printf("usage: Encrypt.exe in-pdf-file out-pdf-file Í [in-pdf-password]\nn");
			printf("Í\n0 : 128 bit RC4  1 : 128 bit AES  2 : 256 bit AES \n");
			return 1;
		}

		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;
		if (argc > 4) {
			PtlParamString password(argv[4]);
			// pX[h̃Zbg
			doc.setPassword(password);
		}
		// PDFt@C[h܂B
		doc.load(input);

		// ZLeBݒ
		switch (argv[3][0])
		{
		case '0':
			{
				// 128 bit RC4
				PtlEncryptStandard128RC4 enc;
				// Í̐ݒ
				setEncrypt(enc);
				// Íݒ
				doc.setEncrypt(enc);
			}
			break;
		case '1':
			{
				// 128 bit AES
				PtlEncryptStandard128AES enc;
				// Í̐ݒ
				setEncrypt(enc);
				// Íݒ
				doc.setEncrypt(enc);
			}
			break;
		case '2':
			{
				// 256 bit AES
				PtlEncryptStandard256AES enc;
				// Í̐ݒ
				setEncrypt(enc);
				// Íݒ
				doc.setEncrypt(enc);
			}
			break;
		default:
			break;
		}

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void setEncrypt(PtlEncryptStandard& enc)
{
	// ̑SẴRecÍ
	enc.setEncryptComponent(PtlEncrypt::ENCRYPT_ALL);

	// [UpX[hl̐ݒ
	enc.setUserPassword("pass");

	// I[i[pX[hl̐ݒ
	enc.setOwnerPassword("test");

	PtlEncryptPermissionType2 typ;

	// ̐ݒ
	// PERM_PRINT_LOW = 1, /* 𑜓x */
	typ.setPrint(PtlEncryptPermissionType2::PERM_PRINT_LOW);

	// ύX̐ݒ
	// PERM_MODIFY_ASSEMBLEDOC = 1, /* y[W̑}A폜A] */
	typ.setModify(PtlEncryptPermissionType2::PERM_MODIFY_ASSEMBLEDOC);

	// eLXgA摜Ȃ̓ẽRs[Lɂ邩ǂ̐ݒ
	// false: LɂȂ
	typ.setCopy(false);

	// XN[[_[foCX̃eLXgANZXLɂ邩ǂ̐ݒ
	// true: Lɂ
	typ.setAccessibility(true);

	// [UANZXtO̐ݒ
	enc.setPermission(typ);
}
