/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFy[Wo

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: ExtractPage.exe in-pdf-file out-folder\n");
		return 1;
	}
	try
	{
		const int MAX_PATH = 260;
		char outputfile[MAX_PATH];

		PtlParamString inputfile(argv[1]);		// oƂȂt@C
		PtlParamString outputfolder(argv[2]);	// o͂tH_

		PtlParamInput input(inputfile);
		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// vpeB̎擾
		PtlDocProperty& docproperty = doc.getDocProperty();

		// ̎擾
		PtlDocInfo& docinfo = docproperty.getDocInfo();

		for(int i=0; i<doc.getPageCount(); i++)
		{
			PtlPDFDocument doc_ext;
			PtlPages& pages = doc_ext.getPages();

			// vpeB̎擾
			PtlDocProperty& docproperty_ext = doc_ext.getDocProperty();

			// ̎擾
			PtlDocInfo& docinfo_ext = docproperty_ext.getDocInfo();

			// ^CgRs[
			docinfo_ext.setTitle(docinfo.getTitle());

			// ҂Rs[
			docinfo_ext.setAuthor(docinfo.getAuthor());

			// TuWFNgRs[
			docinfo_ext.setSubject(docinfo.getSubject());

			// L[[hRs[
			docinfo_ext.setKeywords(docinfo.getKeywords());

			// NG[^Rs[
			docinfo_ext.setCreator(docinfo.getCreator());

			// vf[TRs[
			docinfo_ext.setProducer(docinfo.getProducer());

			// 쐬tRs[
			docinfo_ext.setCreationDate(docinfo.getCreationDate());

			// XVtRs[
			docinfo_ext.setModDate(docinfo.getModDate());

			// y[W}IvV
			// OPTION_COPY_OUTLINES = 0x00000004 y[W}ɂ킹ĂRs[܂B
			// OPTION_COPY_ATTACHEDFILES	= 0x00000008y[W}ɂ킹ēYtt@CRs[܂B
			int insertoption = (PtlPages::OPTION_COPY_OUTLINES | PtlPages::OPTION_COPY_ATTACHEDFILES);

			// y[W̒ǉ(iy[W1P)
			pages.append(doc, i, 1, insertoption);

			// o̓t@C
		#ifdef WIN32
			sprintf_s(outputfile, "%s\\output_%d.pdf", outputfolder.c_str(), i);
		#else
			sprintf(outputfile, "%s/output_%d.pdf", outputfolder.c_str(), i);
		#endif
			PtlParamOutput output(outputfile);

			// t@Cɕۑ܂B
			doc_ext.save(output);
		}

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}
