/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFJ̎擾Ɛݒ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void showAction(const PtlAction& action);
void showDest(const PtlDest& dest);

int main(int argc, char* argv[])
{
	if (argc < 2) {
		printf("usage: GetOpenMode.exe in-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlPDFDocument doc;

		// PDFtB[h܂B
		doc.load(input);

		//vpeB̎擾
		PtlDocProperty docproperty = doc.getDocProperty();

		//J̎擾
		PtlOpenMode& openmode = docproperty.getOpenMode();

		//y[W[h̎擾
		switch (openmode.getPageMode()){
		case PtlOpenMode::PAGE_MODE_USE_NONE:
			printf("PageMode : %d : y[Ŵ\n", PtlOpenMode::PAGE_MODE_USE_NONE);
			break;
		case PtlOpenMode::PAGE_MODE_USE_OUTLINES:
			printf("PageMode : %d : plƃy[W\n", PtlOpenMode::PAGE_MODE_USE_OUTLINES);
			break;
		case PtlOpenMode::PAGE_MODE_USE_THUMBS:
			printf("PageMode : %d : TlCplƃy[W\n", PtlOpenMode::PAGE_MODE_USE_THUMBS);
			break;
		case PtlOpenMode::PAGE_MODE_USE_OC:
			printf("PageMode : %d : C[plƃy[W\n", PtlOpenMode::PAGE_MODE_USE_OC);
			break;
		case PtlOpenMode::PAGE_MODE_USE_ATTACHMENTS:
			printf("PageMode : %d : Ytt@Cplƃy[W\n", PtlOpenMode::PAGE_MODE_USE_ATTACHMENTS);
			break;
		}

		//y[WCAEg̎擾
		switch (openmode.getPageLayout()){
		case PtlOpenMode::PAGE_LAYOUT_SINGLE_PAGE:
			printf("PageLayout : %d : Py[W\n", PtlOpenMode::PAGE_LAYOUT_SINGLE_PAGE);
			break;
		case PtlOpenMode::PAGE_LAYOUT_ONE_COLUMN:
			printf("PageLayout : %d : Ay[W\n", PtlOpenMode::PAGE_LAYOUT_ONE_COLUMN);
			break;
		case PtlOpenMode::PAGE_LAYOUT_TWO_COLUMN_LEFT:
			printf("PageLayout : %d : y[WɂĘAJy[W\n", PtlOpenMode::PAGE_LAYOUT_TWO_COLUMN_LEFT);
			break;
		case PtlOpenMode::PAGE_LAYOUT_TWO_COLUMN_RIGHT:
			printf("PageLayout : %d : y[WEɂĘAJy[W\n", PtlOpenMode::PAGE_LAYOUT_TWO_COLUMN_RIGHT);
			break;
		case PtlOpenMode::PAGE_LAYOUT_TWO_PAGE_LEFT:
			printf("PageLayout : %d : y[WɂČJy[W\n", PtlOpenMode::PAGE_LAYOUT_TWO_PAGE_LEFT);
			break;
		case PtlOpenMode::PAGE_LAYOUT_TWO_PAGE_RIGHT:
			printf("PageLayout : %d : y[WEɂČJy[W\n", PtlOpenMode::PAGE_LAYOUT_TWO_PAGE_RIGHT);
			break;
		}

		//I[vANV̎擾
		showAction(openmode.getOpenAction());
		
		//y[W̎擾(y[Wԍ0x[X)
		// ̈doc̈ɂȂ܂BPDF̈PtlActionGoToRgetDestŎ擾܂B
		showDest(openmode.getOpenDest());

		//EChEIvV擾i_aj
		if ((openmode.getWindowOption() & PtlOpenMode::WINDOWS_OPTION_NONE) == PtlOpenMode::WINDOWS_OPTION_NONE){
			printf("WindowOption : %d : Ȃ\n", PtlOpenMode::WINDOWS_OPTION_NONE);
		}
		if ((openmode.getWindowOption() & PtlOpenMode::WINDOWS_OPTION_FIT_WINDOW) == PtlOpenMode::WINDOWS_OPTION_FIT_WINDOW){
			printf("WindowOption : %d : y[WɃEBhETCY킹\n", PtlOpenMode::WINDOWS_OPTION_FIT_WINDOW);
		}
		if ((openmode.getWindowOption() & PtlOpenMode::WINDOWS_OPTION_CENTER_WINDOW) == PtlOpenMode::WINDOWS_OPTION_CENTER_WINDOW){
			printf("WindowOption : %d : EBhEʒɔzu\n", PtlOpenMode::WINDOWS_OPTION_CENTER_WINDOW);
		}
		if ((openmode.getWindowOption() & PtlOpenMode::WINDOWS_OPTION_FULL_SCREEN) == PtlOpenMode::WINDOWS_OPTION_FULL_SCREEN){
			printf("WindowOption : %d : tXN[[hŊJ\n", PtlOpenMode::WINDOWS_OPTION_FULL_SCREEN);
		}

		//EBhẼ^Cgo[ɕ^Cg\邩ǂ擾itrue: \Afalse: \j
		if (openmode.getDisplayDocTitle()){
			printf("DisplayDocTitle : B\n");
		}else{
			printf("DisplayDocTitle : BȂ\n");
		}

		//[U[C^[tFCXIvV擾i_aj
		if ((openmode.getUIOption() & PtlOpenMode::UI_OPTION_NONE) == PtlOpenMode::UI_OPTION_NONE){
			printf("UIOption : %d : Ȃ\n", PtlOpenMode::UI_OPTION_NONE);
		}
		if ((openmode.getUIOption() & PtlOpenMode::UI_OPTION_HIDE_MENUBAR) == PtlOpenMode::UI_OPTION_HIDE_MENUBAR){
			printf("UIOption : %d : j[o[B\n", PtlOpenMode::UI_OPTION_HIDE_MENUBAR);
		}
		if ((openmode.getUIOption() & PtlOpenMode::UI_OPTION_HIDE_TOOLBAR) == PtlOpenMode::UI_OPTION_HIDE_TOOLBAR){
			printf("UIOption : %d : c[o[B\n", PtlOpenMode::UI_OPTION_HIDE_TOOLBAR);
		}
		if ((openmode.getUIOption() & PtlOpenMode::UI_OPTION_HIDE_WINDOWUI) == PtlOpenMode::UI_OPTION_HIDE_WINDOWUI){
			printf("UIOption : %d : EChERg[B\n", PtlOpenMode::UI_OPTION_HIDE_WINDOWUI);
		}

		//ǂݏグIvV擾
		switch (docproperty.getDirection()) {
		case PtlDocProperty::DIRECTION_L2R:
			printf("Direction : E\n");
			break;
		case PtlDocProperty::DIRECTION_R2L:
			printf("Direction : E獶(A{A؍̂悤ȏc܂)\n");
			break;
		}

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void showAction(const PtlAction& action)
{
	switch (action.getType()){
	case PtlAction::TYPE_NONE:{
		printf("OpenAction : %d : ANVȂ\n", PtlAction::TYPE_NONE);
		break;}
	case PtlAction::TYPE_GOTO:{
		printf("OpenAction : %d : GoToANV\n", PtlAction::TYPE_GOTO);
		PtlActionGoTo act = (PtlActionGoTo&)action;
		//̎擾
		showDest(act.getDest());
		break;}
	case PtlAction::TYPE_GOTO_R:{
		printf("OpenAction : %d : GoToRANV\n", PtlAction::TYPE_GOTO_R);
		PtlActionGoToR act = (PtlActionGoToR&)action;
		//t@CԈړpPDFt@C擾 getFileName()
		printf("FileName : %s\n", act.getFileName().c_str());
		//VEBhEtO擾
		if (act.getNewWindowFlag()){
			printf("NewWindowFlag : true: VEBhEŃI[v\n");
		}else{
			printf("NewWindowFlag : false: Ȃ\n");
		}
		//̎擾
		showDest(act.getDest());
		break;}
	case PtlAction::TYPE_LAUNCH:{
		printf("OpenAction : %d : LaunchANV\n", PtlAction::TYPE_LAUNCH);
		PtlActionLaunch act = (PtlActionLaunch&)action;
		//Nt@C擾
		printf("FileName : %s\n", act.getFileName().c_str());
		//VEBhEtO擾
		if (act.getNewWindowFlag()){
			printf("NewWindowFlag : true: VEBhEŃI[v\n");
		}else{
			printf("NewWindowFlag : false: Ȃ\n");
		}
		break;}
	case PtlAction::TYPE_URI:{
		printf("OpenAction : %d : URIANV\n", PtlAction::TYPE_URI);
		PtlActionURI act = (PtlActionURI&)action;
		//URI擾
		printf("URI : %s\n", act.getURI().c_str());
		break;}
	case PtlAction::TYPE_UNKNOWN:{
		printf("OpenAction : %d : ΉANV\n", PtlAction::TYPE_UNKNOWN);
		break;}
	}
}

void showDest(const PtlDest& dest)
{
	switch (dest.getType()){
	case PtlDest::TYPE_NONE:
		printf("OpenDest : %d : Ȃ\n", PtlDest::TYPE_NONE);
		break;
	case PtlDest::TYPE_XYZ:
		printf("OpenDest : %d : XYZ^\n", PtlDest::TYPE_XYZ);
		break;
	case PtlDest::TYPE_FIT:
		printf("OpenDest : %d : Fit^(S)\n", PtlDest::TYPE_FIT);
		break;
	case PtlDest::TYPE_FIT_H:
		printf("OpenDest : %d : FitH^(ɍ킹)\n", PtlDest::TYPE_FIT_H);
		break;
	case PtlDest::TYPE_FIT_V:
		printf("OpenDest : %d : FitV^(ɍ킹)\n", PtlDest::TYPE_FIT_V);
		break;
	case PtlDest::TYPE_FIT_R:
		printf("OpenDest : %d : FitR^\n", PtlDest::TYPE_FIT_R);
		break;
	case PtlDest::TYPE_FIT_B:
		printf("OpenDest : %d : FitB^\n", PtlDest::TYPE_FIT_B);
		break;
	case PtlDest::TYPE_FIT_BH:
		printf("OpenDest : %d : FitBH^(`̈̕ɍ킹)\n", PtlDest::TYPE_FIT_BH);
		break;
	case PtlDest::TYPE_FIT_BV:
		printf("OpenDest : %d : FitBV^\n", PtlDest::TYPE_FIT_BV);
		break;
	}
	//y[W̎擾
	printf("y[W(PageNumber) : %d y[W\n", dest.getPageNumber());
}

