/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF摜t@CPDFƊPDFւ̃y[Wǉ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: InsertImagePage.exe in-pdf-file insert-image-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);		//PDF
		PtlParamInput insertImage(argv[2]);	//}摜
		PtlParamOutput output(argv[3]);		//oPDF

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		// 摜̃y[W쐬Ɏgp[^NX
		PtlParamImagePage paramImagePage;

		// 摜̕`Ɏgp[^NX
		PtlParamDrawImage paramDrawImage;

		// ͉摜Xg[̐ݒ
		paramDrawImage.setImageStream(insertImage);

		// }`Tiff̃y[Wԍ̐ݒiTifft@Cɂ̂ݗLj 
		// -1ݒ肷ƑSy[W}܂Bݒ肵Ȃꍇ́A-1ݒ肳ꂽƂ݂Ȃ܂
		paramDrawImage.setImagePageNumber(0);

		// y[Wɑ}摜p[^̐ݒB
		paramImagePage.setImage(paramDrawImage);

		// p^Cv̐ݒ PAPER_A4 = 1, /* A4 */
		paramImagePage.setPaperType(PtlParamImagePage::PAPER_A4);

		// 摜zuƂ̗]̐ݒ
		paramImagePage.setMargin(20.0f, 15.0f, 20.0f, 15.0f);

		// 摜̔zu̐ݒ ALIGN_TOP_LEFT = 1, /*  */
		paramImagePage.setAlign(PtlParamImagePage::ALIGN_TOP_LEFT);

		// y[WReiɉ摜y[Wp[^ǉ
		//pages.insert(4, paramImagePage);// 5P
		pages.append(paramImagePage);// ŏI

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

