/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFy[W폜ƃjACYۑ

		 p[^[̎wőSy[W̍폜o܂ASẴy[W폜PDFƂĂȂ肽Ȃ̂ŃG[ƂȂ܂B

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: RemovePages.exe in-pdf-file out-pdf-file 폜@\n\n");
		printf("폜@\n0 : Py[Wڂ폜  1 : Q-Ry[W폜  2 : Sy[W̍폜\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		const char* kind = argv[3];
		switch (kind[0]) {
		case '0':
		case '1':
		case '2':
			break;
		default:
			printf("usage: RemovePages.exe in-pdf-file out-pdf-file 폜@\n\n");
			printf("폜@\n0 : Py[Wڂ폜  1 : Q-Ry[W폜  2 : Sy[W̍폜\n");
			return 1;
		}

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// jACY
		doc.setSaveOption(PtlPDFDocument::SAVE_LINEARIZE);

		// y[W̎擾
		printf("y[WF%d\n", doc.getPageCount());

		//y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		switch (kind[0]) {
		case '0':
			//y[W̍폜
			pages.remove(0);
			break;
		case '1':
			//y[W̍폜
			pages.remove(1,2);
			break;
		case '2':
			//Sy[W̍폜
			pages.removeAll();	// ̂܂saveƃG[ɂȂ܂
			break;
		default:
			break;
		}

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}
