/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF̐ݒ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: SetDocInfo.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// PDF̕vpeB
		PtlDocProperty& docproperty = doc.getDocProperty();

		// PDF̕
		PtlDocInfo& docinf = docproperty.getDocInfo();

		// ^Cgݒ
		docinf.setTitle("^Cg");

		// ҂ݒ
		docinf.setAuthor("");

		// TuWFNgݒ
		docinf.setSubject("TuWFNg");

		// L[[hݒ
		docinf.setKeywords("L[[h");

		// NG[^ݒ
		docinf.setCreator("NGC^");

		// vf[Tݒ
		docinf.setProducer("vf[T");

		// 쐬tݒ(2013/08/01 00:00:00)
		docinf.setCreationDate(PtlDate(2013, 8, 1, 0, 0, 0));

		// XVtݒ(2013/8/16 23:00:00)
		docinf.setModDate(PtlDate(2013, 8, 16, 23, 0, 0));

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
	}	
	return 0;
}
