/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFJ̐ݒ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: SetOpenMode.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// vpeB̎擾
		PtlDocProperty& docproperty = doc.getDocProperty();

		// J̎擾
		PtlOpenMode& openmode = docproperty.getOpenMode();

		// y[W[h̐ݒ PAGE_MODE_USE_THUMBS = 3 /* TlCplƃy[W */
		openmode.setPageMode(PtlOpenMode::PAGE_MODE_USE_THUMBS);

		// y[WCAEg̐ݒ PAGE_LAYOUT_ONE_COLUMN = 2 /* Ay[W */
		openmode.setPageLayout(PtlOpenMode::PAGE_LAYOUT_ONE_COLUMN);

		// I[vANV̐ݒ
		PtlActionGoTo act;
		// PDF̈
		PtlDestFitR dst;
		// y[W̐ݒ(y[Wԍ0x[X)
		dst.setPageNumber(1);
		// left̐ݒ
		dst.setLeft(100.0f);
		//dst.setLeftNull();
		// bottom̐ݒ
		dst.setBottom(100.0f);
		//dst.setBottomNull();
		// right̐ݒ
		dst.setRight(120.0f);
		//dst.setRightNull();
		// top̐ݒ
		dst.setTop(150.0f);
		//dst.setTopNull();
		// zoom̐ݒ
		dst.setZoom(100.0f);
		//dst.setZoomNull();
		act.setDest(dst);
		openmode.setOpenAction(act);

		// EChEIvVݒi_aj
		// WINDOWS_OPTION_FIT_WINDOW = 0x00000001,		/* y[WɃEBhETCY킹 */
		// WINDOWS_OPTION_CENTER_WINDOW = 0x00000002,	/* EBhEʒɔzu */
		openmode.setWindowOption(PtlOpenMode::WINDOWS_OPTION_FIT_WINDOW |PtlOpenMode::WINDOWS_OPTION_CENTER_WINDOW);

		// EBhẼ^Cgo[ɕ^Cg\邩ǂݒitrue: \Afalse: \j
		openmode.setDisplayDocTitle(true);

		// [U[C^[tFCXIvVݒi_aj
		// UI_OPTION_HIDE_WINDOWUI = 0x00000004		/* EChERg[\ */
		openmode.setUIOption(PtlOpenMode::UI_OPTION_HIDE_WINDOWUI);

		// ǂݏグIvVݒ DIRECTION_R2L = 2 /* E獶(A{A؍̂悤ȏc܂)	*/
		docproperty.setDirection(PtlDocProperty::DIRECTION_R2L);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

