/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF{ݒ

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void setRestriction(PtlPDFDocument& doc);
void setWaterMark(PtlParamRestriction& restruction);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: SetRestriction.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFtB[h܂B
		doc.load(input);

		// {ݒ
		setRestriction(doc);
#if 0
		PtlParamRestriction restruction;

		//{\ƂԂ̊Jn(2013/1/1 15:00:30)
		restruction.setValidTermStart(PtlDate(2013,1,1,15,0,30));

		//{\ƂԂ̏I(2014/3/31 9:30:00)
		restruction.setValidTermEnd(PtlDate(2014,3,31,9,30,0));

		//̐ݒ --------------------------
		PtlParamWaterMarkText watermarktext;

		//̔zu̐ݒ ALIGN_CENTER = 5 /*  */
		watermarktext.setAlign(PtlParamWaterMark::ALIGN_CENTER);

		//Ɏw肷镶̐ݒ
		PtlParamString strbuf("Rectriction Test");
		watermarktext.setString(strbuf);

		//Ɏw肷tHg̐ݒ
#ifdef WIN32
		watermarktext.setFont(PtlParamFont("Arial", 180.0f, PtlParamFont::WEIGHT_HEAVY, true, false));
#else
		watermarktext.setFont(PtlParamFont("Courier", 180.0f, PtlParamFont::WEIGHT_HEAVY, true, false));
#endif

		//̕Ɏw肷F̐ݒ
		watermarktext.setTextColor(PtlColorDeviceRGB(0.0f, 0.0f, 1.0f));

		//̉̕Ɏw肷F̐ݒ
		watermarktext.setOutlineColor(PtlColorDeviceRGB(0.0f, 1.0f, 0.0f));

		//̃eLXgΊpɔzuݒ
		watermarktext.setWriteDiagonal(true);

		//{sɕ\EH[^[}[Nݒ
		restruction.setWatermark(watermarktext);

		//{̐ݒ
		doc.setRestriction(restruction);
#endif
		// ʂ̃t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void setRestriction(PtlPDFDocument& doc)
{
	PtlParamRestriction restruction;

	//{\ƂԂ̊Jn(2013/1/1 15:00:30)
	restruction.setValidTermStart(PtlDate(2013,1,1,15,0,30));

	//{\ƂԂ̏I(2014/3/31 9:30:00)
	restruction.setValidTermEnd(PtlDate(2014,3,31,9,30,0));

	// ̐ݒ
	setWaterMark(restruction);

	// {̐ݒ
	doc.setRestriction(restruction);
}

void setWaterMark(PtlParamRestriction& restruction)
{
	PtlParamWaterMarkText watermarktext;

	//̔zu̐ݒ ALIGN_CENTER = 5 /*  */
	watermarktext.setAlign(PtlParamWaterMark::ALIGN_CENTER);

	//Ɏw肷镶̐ݒ
	PtlParamString strbuf("Rectriction Test");
	watermarktext.setString(strbuf);

	//Ɏw肷tHg̐ݒ
#ifdef WIN32
	watermarktext.setFont(PtlParamFont("Arial", 180.0f, PtlParamFont::WEIGHT_HEAVY, true, false));
	#else
	watermarktext.setFont(PtlParamFont("Courier", 180.0f, PtlParamFont::WEIGHT_HEAVY, true, false));
#endif

	//̕Ɏw肷F̐ݒ
	watermarktext.setTextColor(PtlColorDeviceRGB(0.0f, 0.0f, 1.0f));

	//̉̕Ɏw肷F̐ݒ
	watermarktext.setOutlineColor(PtlColorDeviceRGB(0.0f, 1.0f, 0.0f));

	//̃eLXgΊpɔzuݒ
	watermarktext.setWriteDiagonal(true);

	//{sɕ\EH[^[}[Nݒ
	restruction.setWatermark(watermarktext);
}
