/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFeLXgIuWFNg̑}

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void writeString(PtlPage& page);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: WriteString.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// y[W̎擾
		PtlPage page = pages.get(0);

		// eLXgǉ
		writeString(page);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void writeString(PtlPage& page)
{
	//y[WReg̎擾
	PtlContent& content = page.getContent();

	//o
	{
		//o͋`
		PtlRect rect(0.0f, 0.0f, 300.0f, 250.0f);

		//̕`Ɏgp[^NX
		PtlParamWriteString writestring;

		//tHgwɎgp[^NX
		PtlParamFont font;

		//tHg̐ݒ
	#ifdef WIN32
		font.setName("lr");
	#else
		font.setName("Times-Roman");
	#endif

		//TCY̐ݒ
		font.setSize(80.0f);

		//tHg̐ݒ
		writestring.setFont(font);

		//Fݒ
		writestring.setTextColor(PtlColorDeviceRGB(1.0f, 0.0f, 0.0f));

		//o
		content.writeString(rect, PtlContent::ALIGN_CENTER, "writeString Test 1", writestring);
	}

	//]o
	{
		//o͋`
		PtlRect rect(0.0f, 0.0f, 300.0f, 250.0f);

		//̕`Ɏgp[^NX
		PtlParamWriteString writestring;

		//tHgwɎgp[^NX
		PtlParamFont font;

		//tHg̐ݒ
	#ifdef WIN32
		font.setName("MS-Gothic");
	#else
		font.setName("Courier");
	#endif

		//TCY̐ݒ
		font.setSize(40.0f);

		//tHg̐ݒ
		writestring.setFont(font);

		//Fݒ
		writestring.setTextColor(PtlColorDeviceRGB(0.0f, 1.0f, 0.0f));

		//o
		content.writeString(rect, PtlContent::ALIGN_BOTTOM_LEFT, 45.0f, "writeString Test 2", writestring);
	}

	//c̕o
	{
		//o͋`
		PtlRect rect(250.0f, 0.0f, 300.0f, 200.0f);

		//̕`Ɏgp[^NX
		PtlParamWriteString writestring;

		//tHgwɎgp[^NX
		PtlParamFont font;

		//tHg̐ݒ
	#ifdef WIN32
		font.setName("MSP-Mincho");
	#else
		font.setName("Helvetica");
	#endif

		//TCY̐ݒ
		font.setSize(60.0f);

		//EGCg̐ݒ
		font.setWeight(PtlParamFont::WEIGHT_HEAVY);

		//tHg̐ݒ
		writestring.setFont(font);

		//Fݒ
		writestring.setTextColor(PtlColorDeviceRGB(0.0f, 0.0f, 1.0f));

		//o
		content.writeStringV(rect, PtlContent::ALIGN_TOP_LEFT, "writeString Test 3", writestring);
	}
}
